

#    MIDAS Access Client  for the  CAMACAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global CAMACAccessServerHost CAMACAccessServerPort

if {[info exists CAMACAccessServerHost] == 0} then {set CAMACAccessServerHost localhost}
if {[info exists CAMACAccessServerPort] == 0} then {set CAMACAccessServerPort 8015}

variable uri "urn:CAMACAccessServer"
variable proxy "http://$CAMACAccessServerHost:$CAMACAccessServerPort/CAMACAccessServer"

SOAP::create CAMACAccessClient__DefineRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name DefineRegister \
     -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__InquireRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create CAMACAccessClient__ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegisterAttributes \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegistersAttributes \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__DeleteRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name DeleteRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__DeleteRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name DeleteRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegisterAttributes \
     -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegistersAttributes \
     -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__WriteRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegister \
     -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__WriteRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegisters \
     -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__InitialiseRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name InitialiseRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__InitialiseRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name InitialiseRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__ReadRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__ReadRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__InterfaceStatus -proxy $proxy -uri $uri -timeout 5000 \
     -name InterfaceStatus \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create CAMACAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout 5000 \
     -name AccessServerVerbose \
     -params {opt string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide CAMACAccessClient 1.0
