

#    MIDAS Access Client  for the  NetVar service

package require MIDASAccessClient   ;#   load default support procedures

global NetVarServerHost NetVarServerPort

if {[info exists NetVarServerHost] == 0} then {set NetVarServerHost localhost}
if {[info exists NetVarServerPort] == 0} then {set NetVarServerPort 8015}

variable uri "urn:NetVarServer"
variable proxy "http://$NetVarServerHost:$NetVarServerPort/NetVarServer"

proc NetVarClient_Configure {} {
   global  NetVarServerHost NetVarServerPort
   variable proxy

   set proxy "http://$NetVarServerHost:$NetVarServerPort/NetVarServer"

   foreach method [info procs NetVarClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}
SOAP::create NetVarClient__DefineRegister -proxy $proxy -uri $uri -timeout 10000 \
     -name DefineRegister \
     -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__InquireRegisters -proxy $proxy -uri $uri -timeout 10000 \
     -name InquireRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create NetVarClient__ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 10000 \
     -name ReadRegisterAttributes \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 10000 \
     -name ReadRegistersAttributes \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__DeleteRegister -proxy $proxy -uri $uri -timeout 10000 \
     -name DeleteRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__DeleteRegisters -proxy $proxy -uri $uri -timeout 10000 \
     -name DeleteRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 10000 \
     -name WriteRegisterAttributes \
     -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 10000 \
     -name WriteRegistersAttributes \
     -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__WriteRegister -proxy $proxy -uri $uri -timeout 10000 \
     -name WriteRegister \
     -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__WriteRegisters -proxy $proxy -uri $uri -timeout 10000 \
     -name WriteRegisters \
     -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__InitialiseRegister -proxy $proxy -uri $uri -timeout 10000 \
     -name InitialiseRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__InitialiseRegisters -proxy $proxy -uri $uri -timeout 10000 \
     -name InitialiseRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__ReadRegister -proxy $proxy -uri $uri -timeout 10000 \
     -name ReadRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__ReadRegisters -proxy $proxy -uri $uri -timeout 10000 \
     -name ReadRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__InterfaceStatus -proxy $proxy -uri $uri -timeout 10000 \
     -name InterfaceStatus \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create NetVarClient__ServerVerbose -proxy $proxy -uri $uri -timeout 10000 \
     -name ServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide NetVarClient 1.0
