

#    Demo Run Control Application Implementation file

    package require DataAcquisitionControlServer   ;# load generic code

global MIDAS_SimError 0
global MIDAS_DataAcquisitionOptions(Dummy) "dummy"

global MIDAS_DataAcquisitionDemo_TimeUnit
set MIDAS_DataAcquisitionDemo_TimeUnit 500

global MIDAS_DataAcquisitionDemo_Verbose
set MIDAS_DataAcquisitionDemo_Verbose 1

# do what's needed to setup all hardware
proc do_Implementation-SetUp {args} {
       global MIDAS_DataAcquisitionCode 
       global MIDAS_DataAcquisitionDemo_TimeUnit

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-SetUp with args $args"}

       after [expr 10*$MIDAS_DataAcquisitionDemo_TimeUnit] "set MIDAS_DataAcquisitionCode 0"

    return 0
}

# do what's needed to reset all hardware
proc do_Implementation-Reset {args} {
     global MIDAS_DataAcquisitionCode
     global MIDAS_DataAcquisitionDemo_TimeUnit

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-Reset with args $args"}

       after [expr 10*$MIDAS_DataAcquisitionDemo_TimeUnit] "set MIDAS_DataAcquisitionCode 2"

     return 0
}

# do what's needed to stop all "going" hardware streams
proc do_Implementation-Stop {args} {
     global MIDAS_DataAcquisitionCode
     global MIDAS_DataAcquisitionDemo_TimeUnit

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-Stop with args $args"}

     after [expr 3*$MIDAS_DataAcquisitionDemo_TimeUnit] "set MIDAS_DataAcquisitionCode 0"

     return 0
}

# do what's needed to start all halted hardware streams
proc do_Implementation-Go {args} {
     global MIDAS_DataAcquisitionCode
     global MIDAS_DataAcquisitionDemo_TimeUnit
     global MIDAS_SimError

       global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-Go with args $args"}

       incr MIDAS_SimError
       if {$MIDAS_SimError == 5} {
            set MIDAS_DataAcquisitionCode 6
            set MIDAS_DataAcquisitionError 4096
            set MIDAS_DataAcquisitionInfo "simulated error"
            set MIDAS_SimError 0

            set rc 1
       } else {

          after [expr 3*$MIDAS_DataAcquisitionDemo_TimeUnit] "set MIDAS_DataAcquisitionCode 1"
           set rc 0
       }

     return $rc
}

# do what's needed to set Data Acq program control options
proc do_Implementation-SetOption {args} {
     global MIDAS_DataAcquisitionCode
     global MIDAS_DataAcquisitionOptions

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-SetOption with args $args"}

     set Opt [first $args]
     set Vl [second $args]

     set MIDAS_DataAcquisitionOptions($Opt) $Vl

     return 0
}

# do what's needed to get Data Acq program control options
proc do_Implementation-GetOption {args} {
     global MIDAS_DataAcquisitionOptions

     global MIDAS_DataAcquisitionDemo_Verbose
     if {$MIDAS_DataAcquisitionDemo_Verbose} {puts "Entered do_Implementation-GetOption with args $args"}

     set Opt [first $args]
     set z [catch {set MIDAS_DataAcquisitionOptions($Opt)} m]

     return "$m"
}

proc do_Implementation-Counters {} {
       global MIDAS_DataAcquisitionCounters

       incr MIDAS_DataAcquisitionCounters(0)
       incr MIDAS_DataAcquisitionCounters(1)
       incr MIDAS_DataAcquisitionCounters(2)
       incr MIDAS_DataAcquisitionCounters(3)

       return "$MIDAS_DataAcquisitionCounters(0) $MIDAS_DataAcquisitionCounters(1) $MIDAS_DataAcquisitionCounters(2) $MIDAS_DataAcquisitionCounters(3)"
}

proc do_Implementation-Rates {} {
       global MIDAS_DataAcquisitionRates

       set MIDAS_DataAcquisitionRates(0) [expr ($MIDAS_DataAcquisitionRates(0) + 1) & 3]
       set MIDAS_DataAcquisitionRates(1) [expr ($MIDAS_DataAcquisitionRates(1) + 1) & 7]
       set MIDAS_DataAcquisitionRates(2) [expr ($MIDAS_DataAcquisitionRates(2) + 1) & 15]
       set MIDAS_DataAcquisitionRates(3) [expr ($MIDAS_DataAcquisitionRates(3) + 1) & 31]

       return "$MIDAS_DataAcquisitionRates(0) $MIDAS_DataAcquisitionRates(1) $MIDAS_DataAcquisitionRates(2) $MIDAS_DataAcquisitionRates(3)"
}

proc do_Implementation-GetState {} {}


package provide DemoControl 1.0

puts "Demo Run Control Implementation"
